Package wx :: Class KeyEvent

[frames | no frames]

## Type KeyEvent

    object --+
             |
        Object --+
                 |
             Event --+
                     |
                    KeyEvent

This event class contains information about keypress and character events. These events are only sent to the widget that currently has the keyboard focus.

Notice that there are three different kinds of keyboard events in wxWidgets: key down and up events and char events. The difference between the first two is clear - the first corresponds to a key press and the second to a key release - otherwise they are identical. Just note that if the key is maintained in a pressed state you will typically get a lot of (automatically generated) down events but only one up so it is wrong to assume that there is one up event corresponding to each down one.

Both key events provide untranslated key codes while the char event carries the translated one. The untranslated code for alphanumeric keys is always an upper case value. For the other keys it is one of WXK_XXX values from the keycodes table. The translated key is, in general, the character the user expects to appear as the result of the key combination when typing the text into a text entry zone, for example.

A few examples to clarify this (all assume that CAPS LOCK is unpressed and the standard US keyboard): when the 'A' key is pressed, the key down event key code is equal to ASCII A == 65. But the char event key code is ASCII a == 97. On the other hand, if you press both SHIFT and 'A' keys simultaneously , the key code in key down event will still be just 'A' while the char event key code parameter will now be 'A' as well.

Although in this simple case it is clear that the correct key code could be found in the key down event handler by checking the value returned by `ShiftDown`, in general you should use EVT_CHAR for this as for non alphanumeric keys or non-US keyboard layouts the translation is keyboard-layout dependent and can only be done properly by the system itself.

Another kind of translation is done when the control key is pressed: for example, for CTRL-A key press the key down event still carries the same key code 'A' as usual but the char event will have key code of 1, the ASCII value of this key combination.

You may discover how the other keys on your system behave interactively by running the KeyEvents sample in the wxPython demo and pressing some keys while the blue box at the top has the keyboard focus.

Note: If a key down event is caught and the event handler does not call event.Skip() then the coresponding char event will not happen. This is by design and enables the programs that handle both types of events to be a bit simpler.

Note for Windows programmers: The key and char events in wxWidgets are similar to but slightly different from Windows WM_KEYDOWN and WM_CHAR events. In particular, Alt-x combination will generate a char event in wxWidgets (unless it is used as an accelerator).

Tip: be sure to call event.Skip() for events that you don't process in key event function, otherwise menu shortcuts may cease to work under Windows.

# Events

> wx.EVT_KEY_DOWN | Sent when a keyboard key has been pressed
> wx.EVT_KEY_UP | Sent when a keyboard key has been released
> wx.EVT_CHAR | Sent for translated character events.

# Keycode Table

> WXK_BACK | WXK_EXECUTE | WXK_F1 | WXK_NUMPAD_SPACE | WXK_WINDOWS_LEFT
> WXK_TAB | WXK_SNAPSHOT | WXK_F2 | WXK_NUMPAD_TAB | WXK_WINDOWS_RIGHT
> WXK_RETURN | WXK_INSERT | WXK_F3 | WXK_NUMPAD_ENTER | WXK_WINDOWS_MENU
> WXK_ESCAPE | WXK_HELP | WXK_F4 | WXK_NUMPAD_F1 | WXK_SPECIAL1
> WXK_SPACE | WXK_NUMPAD0 | WXK_F5 | WXK_NUMPAD_F2 | WXK_SPECIAL2
> WXK_DELETE | WXK_NUMPAD1 | WXK_F6 | WXK_NUMPAD_F3 | WXK_SPECIAL3
> WXK_LBUTTON | WXK_NUMPAD2 | WXK_F7 | WXK_NUMPAD_F4 | WXK_SPECIAL4
> WXK_RBUTTON | WXK_NUMPAD3 | WXK_F8 | WXK_NUMPAD_HOME | WXK_SPECIAL5
> WXK_CANCEL | WXK_NUMPAD4 | WXK_F9 | WXK_NUMPAD_LEFT | WXK_SPECIAL6
> WXK_MBUTTON | WXK_NUMPAD5 | WXK_F10 | WXK_NUMPAD_UP | WXK_SPECIAL7
> WXK_CLEAR | WXK_NUMPAD6 | WXK_F11 | WXK_NUMPAD_RIGHT | WXK_SPECIAL8
> WXK_SHIFT | WXK_NUMPAD7 | WXK_F12 | WXK_NUMPAD_DOWN | WXK_SPECIAL9
> WXK_ALT | WXK_NUMPAD8 | WXK_F13 | WXK_NUMPAD_PRIOR | WXK_SPECIAL10
> WXK_CONTROL | WXK_NUMPAD9 | WXK_F14 | WXK_NUMPAD_PAGEUP | WXK_SPECIAL11
> WXK_MENU | WXK_MULTIPLY | WXK_F15 | WXK_NUMPAD_NEXT | WXK_SPECIAL12
> WXK_PAUSE | WXK_ADD | WXK_F16 | WXK_NUMPAD_PAGEDOWN | WXK_SPECIAL13
> WXK_CAPITAL | WXK_SEPARATOR | WXK_F17 | WXK_NUMPAD_END | WXK_SPECIAL14
> WXK_PRIOR | WXK_SUBTRACT | WXK_F18 | WXK_NUMPAD_BEGIN | WXK_SPECIAL15
> WXK_NEXT | WXK_DECIMAL | WXK_F19 | WXK_NUMPAD_INSERT | WXK_SPECIAL16
> WXK_END | WXK_DIVIDE | WXK_F20 | WXK_NUMPAD_DELETE | WXK_SPECIAL17
> WXK_HOME | WXK_NUMLOCK | WXK_F21 | WXK_NUMPAD_EQUAL | WXK_SPECIAL18
> WXK_LEFT | WXK_SCROLL | WXK_F22 | WXK_NUMPAD_MULTIPLY | WXK_SPECIAL19
> WXK_UP | WXK_PAGEUP | WXK_F23 | WXK_NUMPAD_ADD | WXK_SPECIAL20
> WXK_RIGHT | WXK_PAGEDOWN | WXK_F24 | WXK_NUMPAD_SEPARATOR |
> WXK_DOWN |  |  | WXK_NUMPAD_SUBTRACT |
> WXK_SELECT |  |  | WXK_NUMPAD_DECIMAL |
> WXK_PRINT |  |  | WXK_NUMPAD_DIVIDE |

Method Summary
KeyEvent | ``__init__`(self, eventType)`
bool | ``AltDown`(self)` Returns `True` if the Alt key was down at the time of the event.
bool | ``CmdDown`(self)` "Cmd" is a pseudo key which is the same as Control for PC and Unix platforms but the special "Apple" (a.k.a as "Command") key on Macs.
bool | ``ControlDown`(self)` Returns `True` if the Control key was down at the time of the event.
int | ``GetKeyCode`(self)` Returns the virtual key code.
int | ``GetModifiers`(self)` Returns a bitmask of the current modifier settings.
Point | ``GetPosition`(self)` Find the position of the event, if applicable.
(x,y) | ``GetPositionTuple`()` Find the position of the event, if applicable.
unsigned int | ``GetRawKeyCode`(self)` Returns the raw key code for this event.
unsigned int | ``GetRawKeyFlags`(self)` Returns the low level key flags for this event.
int | ``GetUniChar`(self)` Returns the Unicode character corresponding to this key event.
int | ``GetUnicodeKey`(self)` Returns the Unicode character corresponding to this key event.
int | ``GetX`(self)` Returns the X position (in client coordinates) of the event, if applicable.
int | ``GetY`(self)` Returns the Y position (in client coordinates) of the event, if applicable.
bool | ``HasModifiers`(self)` Returns true if either CTRL or ALT keys was down at the time of the key event.
bool | ``MetaDown`(self)` Returns `True` if the Meta key was down at the time of the event.
| ``SetUnicodeKey`(self, uniChar)` Set the Unicode value of the key event, but only if this is a Unicode build of wxPython.
bool | ``ShiftDown`(self)` Returns `True` if the Shift key was down at the time of the event.

Property Summary
| `KeyCode`: See `GetKeyCode`
| `m_altDown`
| `m_controlDown`
| `m_keyCode`
| `m_metaDown`
| `m_rawCode`
| `m_rawFlags`
| `m_scanCode`
| `m_shiftDown`
| `m_x`
| `m_y`
| `Modifiers`: See `GetModifiers`
| `Position`: See `GetPosition`
| `RawKeyCode`: See `GetRawKeyCode`
| `RawKeyFlags`: See `GetRawKeyFlags`
| `thisown`: The membership flag
| `UnicodeKey`: See `GetUnicodeKey` and `SetUnicodeKey`
| `X`: See `GetX`
| `Y`: See `GetY`

Method Details

### __init__(self, eventType=wxEVT_NULL)
(Constructor)

Construct a new `wx.KeyEvent`. Valid event types are:

  Parameters:
    `eventType`
    (type=EventType)

  Returns:
    KeyEvent
  Overrides:
    `wx.Event.__init__`

### AltDown(self)

Returns `True` if the Alt key was down at the time of the event.

  Returns:
    bool

### CmdDown(self)

"Cmd" is a pseudo key which is the same as Control for PC and Unix platforms but the special "Apple" (a.k.a as "Command") key on Macs. It makes often sense to use it instead of, say, `ControlDown` because Cmd key is used for the same thing under Mac as Ctrl elsewhere. The Ctrl still exists, it's just not used for this purpose. So for non-Mac platforms this is the same as `ControlDown` and Macs this is the same as `MetaDown`.

  Returns:
    bool

### ControlDown(self)

Returns `True` if the Control key was down at the time of the event.

  Returns:
    bool

### GetKeyCode(self)

Returns the virtual key code. ASCII events return normal ASCII values, while non-ASCII events return values such as WXK_LEFT for the left cursor key. See `wx.KeyEvent` for a full list of the virtual key codes.

Note that in Unicode build, the returned value is meaningful only if the user entered a character that can be represented in current locale's default charset. You can obtain the corresponding Unicode character using `GetUnicodeKey`.

  Returns:
    int

### GetModifiers(self)

Returns a bitmask of the current modifier settings. Can be used to check if the key event has exactly the given modifiers without having to explicitly check that the other modifiers are not down. For example:

    if event.GetModifers() == wx.MOD_CONTROL:
        DoSomething()

  Returns:
    int

### GetPosition(self)

Find the position of the event, if applicable.

  Returns:
    Point

### GetPositionTuple()

Find the position of the event, if applicable.

  Returns:
    (x,y)

### GetRawKeyCode(self)

Returns the raw key code for this event. This is a platform-dependent scan code which should only be used in advanced applications. Currently the raw key codes are not supported by all ports.

  Returns:
    unsigned int

### GetRawKeyFlags(self)

Returns the low level key flags for this event. The flags are platform-dependent and should only be used in advanced applications. Currently the raw key flags are not supported by all ports.

  Returns:
    unsigned int

### GetUniChar(self)

Returns the Unicode character corresponding to this key event. This function is only meaningfule in a Unicode build of wxPython.

  Returns:
    int

### GetUnicodeKey(self)

Returns the Unicode character corresponding to this key event. This function is only meaningfule in a Unicode build of wxPython.

  Returns:
    int

### GetX(self)

Returns the X position (in client coordinates) of the event, if applicable.

  Returns:
    int

### GetY(self)

Returns the Y position (in client coordinates) of the event, if applicable.

  Returns:
    int

### HasModifiers(self)

Returns true if either CTRL or ALT keys was down at the time of the key event. Note that this function does not take into account neither SHIFT nor META key states (the reason for ignoring the latter is that it is common for NUMLOCK key to be configured as META under X but the key presses even while NUMLOCK is on should be still processed normally).

  Returns:
    bool

### MetaDown(self)

Returns `True` if the Meta key was down at the time of the event.

  Returns:
    bool

### SetUnicodeKey(self, uniChar)

Set the Unicode value of the key event, but only if this is a Unicode build of wxPython.

  Parameters:
    `uniChar`
    (type=int)

### ShiftDown(self)

Returns `True` if the Shift key was down at the time of the event.

  Returns:
    bool

Property Details

### KeyCode

See `GetKeyCode`

  Get Method:
    `GetKeyCode`(self)

### Modifiers

See `GetModifiers`

  Get Method:
    `GetModifiers`(self)

### Position

See `GetPosition`

  Get Method:
    `GetPosition`(self)

### RawKeyCode

See `GetRawKeyCode`

  Get Method:
    `GetRawKeyCode`(self)

### RawKeyFlags

See `GetRawKeyFlags`

  Get Method:
    `GetRawKeyFlags`(self)

### thisown

The membership flag

### UnicodeKey

See `GetUnicodeKey` and `SetUnicodeKey`

  Get Method:
    `GetUnicodeKey`(self)
  Set Method:
    `SetUnicodeKey`(self, uniChar)

### X

See `GetX`

  Get Method:
    `GetX`(self)

### Y

See `GetY`

  Get Method:
    `GetY`(self)

Generated by Epydoc 2.1.20050511.rpd on Thu Mar 22 12:14:31 2007 | http://epydoc.sf.net